name: Quicktest

on:
  # Run on pushes, including merges, to all branches except for `stable` and `develop`.
  push:
    branches-ignore:
      - stable
      - develop
    paths-ignore:
      - '**.md'
  # Allow manually triggering the workflow.
  workflow_dispatch:

# Cancels all previous workflow runs for the same branch that have not yet completed.
concurrency:
  # The concurrency group contains the workflow name and the branch name.
  group: ${{ github.workflow }}-${{ github.ref }}
  cancel-in-progress: true

jobs:
  #### QUICK TEST STAGE ####
  # This is a much quicker test which only runs the unit tests and linting against the low/high
  # supported PHP/PHPCS/PHPCSUtils combinations.
  # These are basically the same builds as in the Test->Coverage workflow, but then without doing
  # the code-coverage.
  quicktest:
    runs-on: ubuntu-latest

    strategy:
      matrix:
        # Note, since the release of PHPCS 4.0, 'stable' == latest 4.x.
        php: ['5.4', 'latest']
        dependencies: ['lowest', 'stable']

        exclude:
          - php: '5.4'
            dependencies: 'stable'

        include:
          # Replace the "low PHP" stable build for PHPCS 4.x.
          - php: '7.2'
            dependencies: 'stable'

    name: "QTest${{ matrix.dependencies == 'stable' && ' + Lint' || '' }}: PHP ${{ matrix.php }} - PHPCS ${{ matrix.dependencies }}"

    steps:
      - name: Checkout code
        uses: actions/checkout@08c6903cd8c0fde910a37f88322edcfb5dd907a8 # v5.0.0
        with:
          persist-credentials: false

      - name: Install PHP
        uses: shivammathur/setup-php@bf6b4fbd49ca58e4608c9c89fba0b8d90bd2a39f # 2.35.5
        with:
          php-version: ${{ matrix.php }}
          # With stable PHPCS dependencies, allow for PHP deprecation notices.
          # Unit tests don't need to fail on those for stable releases where those issues won't get fixed anymore.
          ini-values: error_reporting=E_ALL & ~E_DEPRECATED, display_errors=On
          coverage: none

      # Remove PHPCSDevCS as it would (for now) prevent the tests from being able to run against PHPCS 4.x.
      - name: 'Composer: remove PHPCSDevCS'
        run: composer remove --dev phpcsstandards/phpcsdevcs --no-update --no-interaction

      - name: "Composer: use lock file when necessary"
        if: ${{ matrix.dependencies == 'lowest' }}
        run: composer config --unset lock

      # Install dependencies and handle caching in one go.
      # @link https://github.com/marketplace/actions/install-php-dependencies-with-composer
      - name: Install Composer dependencies
        uses: "ramsey/composer-install@3cf229dc2919194e9e36783941438d17239e8520" # 3.1.1
        with:
          # Bust the cache at least once a month - output format: YYYY-MM.
          custom-cache-suffix: $(date -u "+%Y-%m")

      - name: "Composer: set PHPCS/PHPCSUtils version for tests (lowest)"
        if: ${{ matrix.dependencies == 'lowest' }}
        run: >
          composer update --prefer-lowest --no-scripts --no-interaction
          squizlabs/php_codesniffer
          phpcsstandards/phpcsutils

      - name: Lint against parse errors
        if: matrix.dependencies == 'stable'
        run: composer lint

      - name: Grab PHPCS version
        id: phpcs_version
        # yamllint disable-line rule:line-length
        run: echo "VERSION=$(vendor/bin/phpcs --version | grep --only-matching --max-count=1 --extended-regexp '\b[0-9]+\.[0-9]+')" >> "$GITHUB_OUTPUT"

      - name: Run the unit tests (PHPCS 3.x)
        if: ${{ startsWith( steps.phpcs_version.outputs.VERSION, '3.' ) }}
        run: composer test-phpcs3

      - name: Run the unit tests (PHPCS 4.x)
        if: ${{ startsWith( steps.phpcs_version.outputs.VERSION, '4.' ) }}
        run: composer test-phpcs4
